import "./style.css";
import { defineComponent as Z, computed as k, resolveComponent as P, createElementBlock as A, openBlock as y, Fragment as J, renderList as ee, withDirectives as te, normalizeClass as R, unref as g, createElementVNode as O, normalizeStyle as ne, createCommentVNode as B, createBlock as Y, withModifiers as ae, renderSlot as oe, mergeProps as re, vShow as se, ref as Q, reactive as V, provide as ie, onActivated as le, onDeactivated as ce, watch as de, onMounted as ue, onBeforeUnmount as pe, nextTick as ge, withCtx as X, createVNode as U, toDisplayString as fe } from "vue";
import { PluginPanel as me } from "@opentiny/tiny-engine-common";
import { constants as he } from "@opentiny/tiny-engine-utils";
import { useCanvas as m, useMaterial as ve, useLayout as $, getMergeMeta as be, useMessage as ye, useHistory as De } from "@opentiny/tiny-engine-meta-register";
import { extend as Ce } from "@opentiny/vue-renderless/common/object";
const Se = ["draggable", "onClick", "onMouseenter", "onDragstart", "onDragover", "onDragenter"], _e = {
  key: 0,
  class: "expand-icon"
}, Ne = /* @__PURE__ */ Z({
  __name: "DraggableTree",
  props: {
    data: {
      type: Array,
      default: () => []
    },
    active: {
      type: String
    },
    actives: {
      type: Array,
      default: () => []
    },
    idKey: {
      type: String,
      default: "id"
    },
    labelKey: {
      type: String,
      default: "label"
    },
    childrenKey: {
      type: String,
      default: "children"
    },
    draggable: {
      type: Boolean,
      default: !1
    },
    disallowDrop: {
      type: Function,
      default: () => !1
    }
  },
  emits: ["click", "mouseenter", "drop"],
  setup(f, { emit: h }) {
    const r = f, i = k(() => r.actives.length === 0 && r.active ? [r.active] : r.actives), v = (e) => {
      const { idKey: t, labelKey: a, childrenKey: o } = r, c = e[t], u = e[a], p = e[o], s = { id: c, label: u, rawData: e };
      return Array.isArray(p) && (s.children = p.map((b) => v(b))), s;
    }, I = (e) => Array.isArray(e) ? e.map((t) => v(t)) : [], D = k(() => I(r.data)), x = () => {
      const e = Q({});
      return { collapseMap: e, setCollapse: (o, c) => {
        e.value[o] = c;
      }, switchCollapse: (o) => {
        e.value[o] = !e.value[o];
      } };
    }, { collapseMap: C, setCollapse: d, switchCollapse: M } = x(), S = (e, t, a = 0, o = !1) => {
      const { children: c, ...u } = e, p = (c || []).map((b) => S(b, e.id, a + 1, o || C.value[e.id])).flat(), s = {
        ...u,
        parentId: t,
        level: a,
        hasChildren: (c == null ? void 0 : c.length) > 0,
        collapsed: o
      };
      return p.forEach((b) => {
        b.parent || (b.parent = s);
      }), [s].concat(p);
    }, _ = (e) => S({ children: e }, null, -1).slice(1), E = k(() => _(D.value)), w = h, K = (e, t) => {
      w("click", e, t);
    }, L = (e) => {
      w("mouseenter", e);
    }, z = () => {
      const e = { dragged: null, hovering: null, position: "", borderClass: "", forbidInsert: !1 }, t = V({ ...e });
      return { draggingState: t, resetDraggingState: () => {
        Object.assign(t, e);
      } };
    }, { draggingState: l, resetDraggingState: j } = z(), F = (e, t) => {
      r.draggable && (e.dataTransfer.setDragImage(new Image(), 0, 0), l.dragged = t, t.hasChildren && d(t.id, !0));
    }, G = (e) => {
      const t = e.currentTarget.getBoundingClientRect(), a = e.clientY - t.top, o = 8;
      return a <= o ? { position: "top", borderClass: "border-top" } : a >= t.height - o ? { position: "bottom", borderClass: "border-bottom" } : { position: "center", borderClass: "border-all" };
    }, T = (e, t) => {
      if (!r.draggable)
        return;
      const a = G(e);
      if (t.id === E.value[0].id && a.position !== "center") {
        e.preventDefault();
        return;
      }
      if (r.disallowDrop({ dragged: l.dragged, target: t, position: a.position })) {
        Object.assign(l, { ...a, hovering: t, forbidInsert: !0 });
        return;
      }
      e.preventDefault(), Object.assign(l, { ...a, hovering: t, forbidInsert: !1 });
    }, N = () => {
      if (!r.draggable || l.forbidInsert)
        return;
      const { dragged: e, hovering: t, position: a } = l;
      w("drop", { dragged: e, target: t, position: a });
    }, H = () => {
      j();
    }, n = (e) => {
      if (!r.draggable)
        return;
      const t = e.currentTarget.getBoundingClientRect(), a = 4;
      (e.clientX <= t.left + a || e.clientX >= t.right - a || e.clientY <= t.top + a || e.clientY >= t.bottom - a) && Object.assign(l, { hovering: null });
    };
    return (e, t) => {
      const a = P("svg-icon");
      return y(), A("div", {
        class: "draggable-tree",
        onDragleave: n
      }, [
        (y(!0), A(J, null, ee(E.value, (o) => {
          var c, u, p;
          return te((y(), A("div", {
            key: o.id,
            class: R([
              "tree-row",
              "flex-center",
              {
                active: i.value.includes(o.id),
                dragging: ((c = g(l).hovering) == null ? void 0 : c.id) === o.id,
                "border-all": ((u = g(l).hovering) == null ? void 0 : u.id) === o.id && g(l).position === "center",
                forbid: g(l).forbidInsert
              }
            ]),
            draggable: f.draggable ? "true" : void 0,
            onClick: (s) => K(s, o),
            onMouseenter: (s) => L(o),
            onDragstart: (s) => F(s, o),
            onDragover: (s) => T(s, o),
            onDragenter: (s) => T(s, o),
            onDrop: N,
            onDragend: H
          }, [
            O("div", {
              class: "content flex-center",
              style: ne({ paddingLeft: `${12 * o.level}px` })
            }, [
              o.hasChildren ? B("", !0) : (y(), A("span", _e)),
              o.hasChildren ? (y(), Y(a, {
                key: 1,
                name: "dropdown",
                class: R(["expand-icon", { rotate: g(C)[o.id] }]),
                onClick: ae((s) => g(M)(o.id), ["stop"])
              }, null, 8, ["class", "onClick"])) : B("", !0),
              O("div", {
                class: R([
                  "slot-content",
                  "flex-center",
                  {
                    [g(l).borderClass]: ((p = g(l).hovering) == null ? void 0 : p.id) === o.id && g(l).position !== "center",
                    forbid: g(l).forbidInsert
                  }
                ])
              }, [
                oe(e.$slots, "content", re({ ref_for: !0 }, o), void 0, !0)
              ], 2)
            ], 4)
          ], 42, Se)), [
            [se, !o.collapsed]
          ]);
        }), 128))
      ], 32);
    };
  }
}), W = (f, h) => {
  const r = f.__vccOpts || f;
  for (const [i, v] of h)
    r[i] = v;
  return r;
}, ke = /* @__PURE__ */ W(Ne, [["__scopeId", "data-v-33e270e9"]]), { PAGE_STATUS: q } = he, xe = {
  components: {
    PluginPanel: me,
    DraggableTree: ke
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(f, { emit: h }) {
    const { pageState: r } = m(), { getMaterial: i } = ve(), { PLUGIN_NAME: v } = $(), I = k(() => {
      var n;
      return (n = f.fixedPanels) == null ? void 0 : n.includes(v.OutlineTree);
    }), { useMultiSelect: D, registerHotkeyEvent: x, removeHotkeyEvent: C } = be("engine.canvas.container").api, d = k(() => D().multiSelectedStates.value.map((n) => n.id)), M = V({
      emitEvent: h
    });
    ie("panelState", M);
    const S = (n) => {
      const e = (t) => (t.forEach((a) => {
        a.show = r.nodesStatus[a.id] !== !1, a.showEye = !a.show;
        const o = a.children;
        Array.isArray(o) && e(a.children);
      }), t);
      return [{ ...e([Ce(!0, {}, n)])[0], componentName: "body", id: "body" }];
    }, _ = V({
      pageSchema: [],
      isLock: k(
        () => ![q.Occupy, q.Guest].includes($().layoutState.pageStatus.state)
      )
    }), { subscribe: E, unsubscribe: w } = ye();
    le(() => {
      _.pageSchema = S(r.pageSchema), E({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({ operation: n }) => {
          (n == null ? void 0 : n.type) !== "changeProps" && (_.pageSchema = S(r.pageSchema));
        }
      });
    }), ce(() => {
      w({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }), de(
      () => r.currentSchema,
      () => {
        const { getSchema: n } = m();
        _.pageSchema = S(n());
      }
    );
    const K = (n) => r.nodesStatus[n] !== !1, L = (n) => {
      n.show = !n.show, r.nodesStatus[n.id] = n.show;
      const { getRenderer: e, clearSelect: t } = m().canvasApi.value;
      e().setCondition(n.id, n.show), t();
    }, z = (n) => {
      const { clearSelect: e } = m().canvasApi.value;
      m().operateNode({
        type: "delete",
        id: n.id
      }), e(), De().addHistory();
    }, l = (n) => {
      const { hoverNode: e } = m().canvasApi.value;
      e(n.id);
    }, j = ({ dragged: n, target: e, position: t }) => {
      if (n.id === "body")
        return !0;
      const a = t === "center" ? e : e.parent;
      if (a.id === "body")
        return !1;
      const { getConfigure: o, allowInsert: c } = m().canvasApi.value;
      return !c(o(a.rawData.componentName), n.rawData);
    }, F = ({ dragged: n, target: e, position: t }) => {
      if (n.id === e.id || t === "center" && e.rawData.children.some((u) => u.id === n.id))
        return;
      if (t !== "center") {
        const u = e.parent.rawData.children, p = u.findIndex((b) => b.id === e.id), s = u[t === "top" ? p - 1 : p + 1];
        if (n.id === (s == null ? void 0 : s.id))
          return;
      }
      const { insertNode: a, removeNode: o, selectNode: c } = m().canvasApi.value;
      o(n.id), a(
        { data: n.rawData, node: e.rawData, parent: e.parent.rawData },
        t === "center" ? "in" : t
      ), ge(() => {
        c(n.id, "clickTree");
      });
    }, G = (n, e) => {
      const t = n.ctrlKey || n.metaKey, { selectNode: a } = m().canvasApi.value;
      a(e.id, "clickTree", t);
    }, T = (n) => (i(n.rawData.componentName).icon || "plugin-icon-page").toLowerCase(), N = Q(null), H = () => N.value.$el.contains(document.activeElement);
    return ue(() => {
      N.value && x(document, { eventFilter: H });
    }), pe(() => {
      N.value && C(document);
    }), {
      panelFixed: I,
      selectedIds: d,
      panelRef: N,
      eyeOpen: K,
      delNode: z,
      showNode: L,
      state: _,
      PLUGIN_NAME: v,
      pageState: r,
      getIconName: T,
      handleClickRow: G,
      handleMouseEnterRow: l,
      disallowDrop: j,
      handleDrop: F
    };
  }
}, Me = { class: "row-content" };
function we(f, h, r, i, v, I) {
  const D = P("svg-icon"), x = P("draggable-tree"), C = P("plugin-panel");
  return y(), Y(C, {
    tabindex: "0",
    title: "大纲树",
    ref: "panelRef",
    class: "outlinebox plugin-tree",
    "fixed-name": i.PLUGIN_NAME.OutlineTree,
    fixedPanels: r.fixedPanels,
    onClose: h[0] || (h[0] = (d) => f.$emit("close"))
  }, {
    content: X(() => [
      U(x, {
        "label-key": "componentName",
        data: i.state.pageSchema,
        draggable: !0,
        actives: i.selectedIds,
        "disallow-drop": i.disallowDrop,
        class: "outline-tree",
        onClick: i.handleClickRow,
        onMouseenter: i.handleMouseEnterRow,
        onDrop: i.handleDrop
      }, {
        content: X((d) => [
          O("div", Me, [
            i.getIconName(d) ? (y(), Y(D, {
              key: 0,
              name: i.getIconName(d)
            }, null, 8, ["name"])) : B("", !0),
            O("span", {
              class: R(["row-label", { "node-isblock": d.rawData.componentType === "Block" }])
            }, fe(d.label), 3),
            d.id !== "body" ? (y(), A(J, { key: 1 }, [
              U(D, {
                name: i.eyeOpen(d.id) ? "eye" : "eye-invisible",
                onMouseup: (M) => i.showNode(d.rawData)
              }, null, 8, ["name", "onMouseup"]),
              U(D, {
                name: "delete",
                onMouseup: (M) => i.delNode(d.rawData)
              }, null, 8, ["onMouseup"])
            ], 64)) : B("", !0)
          ])
        ]),
        _: 1
      }, 8, ["data", "actives", "disallow-drop", "onClick", "onMouseenter", "onDrop"])
    ]),
    _: 1
  }, 8, ["fixed-name", "fixedPanels"]);
}
const Ae = /* @__PURE__ */ W(xe, [["render", we], ["__scopeId", "data-v-bf2e705b"]]), Ie = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  widthResizable: !0,
  align: "leftTop"
}, Ke = {
  ...Ie,
  entry: Ae
};
export {
  Ke as default
};
